<template>
<div id="table" class="app-container calendar-list-container">
  <!-- 查询和其他操作 -->
  <div class="filter-container" style="margin: 10px 0 10px 0;">
    <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
      <el-form-item label="用户ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.userId" placeholder="请输入用户ID"></el-input>
      </el-form-item>
      <el-form-item label="妹子ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.girlId" placeholder="请输入妹子ID"></el-input>
      </el-form-item>
      <el-form-item label="评论类型">
        <el-select v-model="queryParams.commentType" placeholder="评论类型"  class="filter-item" style="width: 200px;">
          <el-option label="全部" value=""></el-option>
          <el-option label="评论" value="1">评论</el-option>
          <el-option label="回复" value="2">回复</el-option>
        </el-select>
      </el-form-item>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">查找</el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-excel" @click="exportData">导出Excel</el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-addComment" @click="handleAddComment">+添加评论</el-button>
    </el-form>
    <!--<el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit" v-permission="'/pictureAtlas/add'">添加</el-button>-->
  </div>

    <el-table :data="tableData" style="width:100%" class="show_table" >
      <el-table-column label="用户id" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.userId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="妹子id" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.girlId }}</span>
        </template>
      </el-table-column>
	    <el-table-column label="名字名称" width="160" align="center">
	      <template slot-scope="scope">
	        <span>{{ scope.row.girlName }}</span>
	      </template>
	    </el-table-column>
      <el-table-column label="评论类型" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.firstCommentUid!=0?'回复':'评论' }}</span>
        </template>
      </el-table-column>
	    <el-table-column label="身材" width="100" align="center">
	      <template slot-scope="scope">
	        <span>{{ scope.row.score }}</span>
	      </template>
	    </el-table-column>
      <el-table-column label="颜值" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.score1 }}</span>
        </template>
      </el-table-column>
      <el-table-column label="服务" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.score2 }}</span>
        </template>
      </el-table-column>
      <el-table-column label="评价内容" width="160" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.content }}</span>
        </template>
      </el-table-column>
      <el-table-column label="是否显示" width="160" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.status == 1">显示</span>
          <span v-else-if="scope.row.status == 0">隐藏</span>
        </template>
      </el-table-column>
      <el-table-column label="评价时间" width="160" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" min-width="60" fixed="right" align="center">
        <template slot-scope="scope">
          <!--<el-button @click="handleEdit(scope.row)" type="primary" size="small" v-permission="'/girlOrder/edit'">编辑</el-button>-->
          <el-button @click="handleEdit(scope.row)"  type="primary" size="small">编辑</el-button>
          <el-button v-if="scope.row.firstCommentUid==0" @click="handleAdd(scope.row)"  type="primary" size="small">回复</el-button>
          <el-button @click="handleUpdateStatus(scope.row,0)" v-if="scope.row.status == 1" type="primary" size="small">隐藏</el-button>
          <el-button @click="handleUpdateStatus(scope.row,1)" v-if="scope.row.status == 0" type="primary" size="small">显示</el-button>
        </template>
      </el-table-column>
	  </el-table>

		<!--分页-->
    <div class="block">
        <el-pagination
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
          :current-page.sync="currentPage"
          :page-sizes="[10,40, 80, 120, 200]"
          :page-size="pageSize"
          layout="total, prev, pager, next, jumper, sizes"
          :total="total">
        </el-pagination>
    </div>
  <!-- 添加或修改对话框 -->
  <el-dialog :title="title" :close-on-click-modal="false" :visible.sync="dialogFormVisible" :before-close="handleClose" width="30%">
    <el-form :model="form" ref="form">
      <el-form-item label="uid:" :label-width="formLabelWidth">
        <el-input readonly="readonly"
          v-model="form.uid">
        </el-input>
      </el-form-item>
      <el-form-item v-if="title=='编辑'" label="用户id:" :label-width="formLabelWidth">
        <el-input readonly="readonly"
                  v-model="form.userId">
        </el-input>
      </el-form-item>
      <el-form-item v-if="title=='添加'" label="用户id:" :label-width="formLabelWidth">
        <el-input readonly="readonly"
                  v-model="form.userId">
          {{form.userId}}
        </el-input>
      </el-form-item>
      <el-form-item label="妹子id:" :label-width="formLabelWidth">
        <el-input readonly="readonly"
                  v-model="form.girlId">
        </el-input>
      </el-form-item>
      <el-form-item label="妹子名称:" :label-width="formLabelWidth">
        <el-input readonly="readonly"
                  v-model="form.girlName">
        </el-input>
      </el-form-item>
      <el-form-item v-if="title=='编辑'" label="身材:" :label-width="formLabelWidth">
        <el-input
                  v-model="form.score">
        </el-input>
      </el-form-item>
      <el-form-item v-if="title=='编辑'" label="颜值:" :label-width="formLabelWidth">
        <el-input
          v-model="form.score1">
        </el-input>
      </el-form-item>
      <el-form-item v-if="title=='编辑'" label="服务:" :label-width="formLabelWidth">
        <el-input
          v-model="form.score2">
        </el-input>
      </el-form-item>
      <el-form-item v-if="title=='编辑'" label="评价内容:" :label-width="formLabelWidth">
        <el-input
          type="textarea"
          :rows="6"
          v-model="form.content">
        </el-input>
      </el-form-item>
      <el-form-item v-if="title=='添加'" label="原评价:" :label-width="formLabelWidth">
        <el-input
          type="textarea" readonly="readonly"
          :rows="6"
          v-model="form.content">
        </el-input>
      </el-form-item>

        <el-form-item v-if="title=='添加'" label="用户id" :label-width="formLabelWidth">
          <input type="radio" v-model="form.isOfficial" value="1">&nbsp; 官方ID &nbsp;
          <input type="radio" v-model="form.isOfficial" value="0">&nbsp; 用户ID &nbsp;
          <el-input
                  v-model="form.userId1">
          </el-input>
      </el-form-item>
      <el-form-item v-if="title=='添加'" label="回复内容:" :label-width="formLabelWidth">
        <el-input
          type="textarea"
          :rows="6"
          v-model="form.content1">b
        </el-input>
      </el-form-item>

    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button @click="handleClose">取 消</el-button>
      <el-button type="primary" @click="submitForm">确 定</el-button>
    </div>
  </el-dialog>
  <!-- 添加评论对话框 -->
  <el-dialog :title="title" :close-on-click-modal="false" :visible.sync="addCommentDialogFormVisible" :before-close="addCommentHandleClose" width="30%">
    <el-form :model="addCommentForm" ref="addCommentForm">
      <el-form-item label="用户id:" :label-width="formLabelWidth">
        <el-input v-model="addCommentForm.userId">
        </el-input>
      </el-form-item>
      <el-form-item label="妹子id:" :label-width="formLabelWidth">
        <el-input v-model="addCommentForm.girlId">
        </el-input>
      </el-form-item>
      <el-form-item label="妹子名称:" :label-width="formLabelWidth">
        <el-input v-model="addCommentForm.girlName">
        </el-input>
      </el-form-item>
      <el-form-item  label="身材:" :label-width="formLabelWidth">
        <el-input
          v-model="addCommentForm.score">
        </el-input>
      </el-form-item>
      <el-form-item label="颜值:" :label-width="formLabelWidth">
        <el-input
          v-model="addCommentForm.score1">
        </el-input>
      </el-form-item>
      <el-form-item label="服务:" :label-width="formLabelWidth">
        <el-input
          v-model="addCommentForm.score2">
        </el-input>
      </el-form-item>
      <el-form-item  label="评价内容:" :label-width="formLabelWidth">
        <el-input
          type="textarea"
          :rows="6"
          v-model="addCommentForm.content">
        </el-input>
      </el-form-item>

    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button @click="addCommentHandleClose">取 消</el-button>
      <el-button type="primary" @click="submitAddCommentForm">确 定</el-button>
    </div>
  </el-dialog>
  </div>
</template>

<script>
import {addGirlOrderComment, addCommentGirlOrderComment, editGirlOrderComment, getGirlOrderCommentList} from "../../api/girlOrderComment";
import {
  export_json_to_excel
} from "@/vendor/Export2Excel";

export default {
  created() {
    this.girlOrderCommentList();
  },
  data() {
    return {
      queryParams:{//查询参数
        userId: "", //用户ID
        girlId: "", //妹子ID
        commentType:"" ,
      },
      tableData: [],
      currentPage: 1,
      total: null,
      pageSize: 10,
      dialogFormVisible: false, //控制弹出框
      addCommentDialogFormVisible: false, //控制弹出框
      form: {
        uid:"",
        userId: "",
        userId1: "",
        isOfficial: 0,
        girlId: "",
        girlName: "",
        score: 0,
        score1: 0,
        score2: 0,
        content:"",
        content1:"",
        firstCommentUid:0,
        toUid:0,
        status:0
      },
      addCommentForm: {
        userId: "",
        girlId: "",
        girlName: "",
        score: 0,
        score1: 0,
        score2: 0,
        content:"",
        firstCommentUid:0,
        orderId: "",
      },
    };
  },
  methods: {
    girlOrderCommentList: function() {

      this.queryParams.currentPage = this.currentPage;
      this.queryParams.pageSize = this.pageSize;
      getGirlOrderCommentList(this.queryParams).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },

    submitForm: function() {
      if (this.title=='编辑') {
        editGirlOrderComment(this.form).then(response => {
          if (response.code == this.$ECode.SUCCESS) {
            this.$commonUtil.message.success(response.message)
            this.dialogFormVisible = false;
            this.girlOrderCommentList();
          } else {
            this.$commonUtil.message.error(response.message)
          }
        });
      }
      if (this.title=='添加'){
        this.form.toUid = this.form.uid;
        this.form.firstCommentUid = this.form.toUid;
        this.form.userId = this.form.userId1;
        this.form.content = this.form.content1;
        addGirlOrderComment(this.form).then(response => {
          if (response.code == this.$ECode.SUCCESS) {
            this.$commonUtil.message.success(response.message)
            this.dialogFormVisible = false;
            this.girlOrderCommentList();
          } else {
            this.$commonUtil.message.error(response.message)
          }
        });
      }
    },
    submitAddCommentForm: function() {
      addCommentGirlOrderComment(this.addCommentForm).then(response => {
          if (response.code == this.$ECode.SUCCESS) {
            this.$commonUtil.message.success(response.message)
            this.addCommentDialogFormVisible = false;
            this.girlOrderCommentList();
          } else {
            this.$commonUtil.message.error(response.message)
          }
        });
    },

    handleEdit: function(row) {
      this.title = "编辑";
      this.dialogFormVisible = true;
      this.form = row;
    },
    handleAdd: function(row) {
      this.title = "添加";
      this.dialogFormVisible = true;
      this.form = row;
    },
    handleAddComment: function() {
      this.title = "添加评论"
      this.addCommentDialogFormVisible = true;
    },
    handleClose(){
      this.dialogFormVisible = false;
      this.girlOrderCommentList();
    },
    addCommentHandleClose(){
      this.addCommentDialogFormVisible = false;
      this.girlOrderCommentList();
    },

    handleUpdateStatus(row,status){
      this.form = row;
      this.form.status = status;
      editGirlOrderComment(this.form).then(response => {
        if (response.code == this.$ECode.SUCCESS) {
          this.$commonUtil.message.success(response.message)
          this.dialogFormVisible = false;
          this.girlOrderCommentList();
        } else {
          this.$commonUtil.message.error(response.message)
        }
      });
    },

    // 导出excel数据
    exportData() {
      // 表头对应关系
      const headers = {
        '用户ID': 'userId',
        '妹子ID': 'girlId',
        '名字名称': 'amount',
        '评论类型': 'firstCommentUid',
        '身材': 'score',
        '颜值': 'score1',
        '服务': 'score2',
        '评价内容': 'content',
        '评价时间': 'createTime',
      }

      this.queryParams.currentPage = 1;
      this.queryParams.pageSize = 10000;
      getGirlOrderCommentList(this.queryParams).then(response => {
        const data = this.formatJson(headers, response.data.records)  // list是你的数据源，可以自己重新处理数据内容和类型
        export_json_to_excel(Object.keys(headers), data, '用户评价纪录列表')
      });
    },
    // 该方法负责将数组转化成二维数组
    formatJson(headers, rows) {
      // 首先遍历数组
      return rows.map(item => {
        return Object.keys(headers).map(key => {
          if (headers[key] === 'firstCommentUid') {
            if(item[headers[key]] ==0){
              return '回复';
            }else {
              return '评论';
            }
          }
          return item[headers[key]]
        })
      })
    },

    // 内容改变，触发监听
    tagContentChange: function() {
      // this.form.tagUid = this.tagValue.join(",");
    },
    projectContentChange: function() {
      // this.form.projectUid = this.projectValue;
    },

    handleFind: function() {
      this.currentPage = 1
      this.girlOrderCommentList();
    },
    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.girlOrderCommentList();
    },
    //改变页码
    handleCurrentChange(val) {
      this.currentPage = val;
      this.girlOrderCommentList();
    },


  }
};
</script>
<style scoped>
.cover-icon {
 position: absolute;
 /*top: 40px;*/
 left: 80px;
 z-index: 100;
 color: aliceblue;
 background-color: #9d0006;
}
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  margin: 0, 0, 0, 10px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 100px;
  height: 100px;
  line-height: 100px;
  text-align: center;
  border: 1px dashed #c0ccda;
  border-radius: 8px;
}
.inputClass {
  position: absolute;
}
.imgBody {
  width: 100px;
  height: 100px;
  border: solid 2px #ffffff;
  float: left;
  position: relative;
}
.uploadImgBody {
  margin-left: 5px;
  width: 100px;
  height: 100px;
  border: dashed 1px #c0c0c0;
  float: left;
  position: relative;
}
.uploadImgBody :hover {
  border: dashed 1px #00ccff;
}
.inputClass {
  position: absolute;
}
.show_table {
  background-color: #dde;
  width: 100%;
  height: 100%;
  overflow: auto;
  position: relative;
}
.scroll {
  width: 100%;
  height: calc(100vh - 131px);
  overflow: hidden;
  overflow-y: auto;
}
.showimg {
  width: 357px;
  height: 467px;
  background-color: royalblue;

}
.video-js {
  width: 400px;
  height: 467px;
}
</style>
